﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr169_1
{
    // Объявление делегата:
    delegate void MyDelegate(string txt);

    // Класс с полем, являющимся ссылкой на экземпляр делегата: 
    class MyClass {
        // Поле является ссылкой на экземпляр делегата:
        public MyDelegate apply;
        // Конструктор:
        public MyClass(MyDelegate md) { 
            apply = md;
        }
    }

    // Класс: 
    class Alpha {
        // Закрытое текстовое поле: 
        private string name;
        // Метод для присваивания значения полю: 
        public void set(string t) { 
            name = t;
        }
        // Переопределение метода ToString(): 
        public override string ToString() { 
            return name;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод: 
        static void Main()
        {
            // Создание объекта:
            Alpha A = new Alpha();
            // Создание объекта
            // (аргумент конструктора - ссылка на метод): 
            MyClass obj = new MyClass(A.set);
            // Вызов экземпляра делегата: 
            obj.apply("Объект A");
            // Проверка поля объекта: 
            Console.WriteLine(A);
            // Создание объекта:
            Alpha B = new Alpha();
            // Полю значением присваивается ссылка на метод: 
            obj.apply = B.set;
            // Вызов экземпляра делегата: 
            obj.apply("Объект B");
            // Проверка поля объекта:
            Console.WriteLine(B);
            // Добавление метода в список вызовов экземпляра
            // делегата:
            obj.apply += A.set;
            // Вызов экземпляра делегата: 
            obj.apply("Объект X");
            // Проверка полей объектов:
            Console.WriteLine(A + " и " + B);
            // Удаление метода из списка вызовов экземпляра
            // делегата:
            obj.apply -= B.set;
            // Вызов экземпляра делегата: 
            obj.apply("Объект A");
            // Проверка полей объектов:
            Console.WriteLine(A + " и " + B);
            // Задержка:
            Console.ReadLine();
        }
    }
}
